<?php

class SlideItem extends FileItem
{
    public $enablepreview = true;
    protected $_fields=false;
    protected $_source=false;
    protected $_sourcename=false;
	protected $_templatepreview=false;
    protected $newtype='slide';
    
    public $itemPerPage=0;
	public $viewBox="0 0 1280 720";
	
	protected $previews=array();
    
	public $datafeedsentries=false;
	
    function __construct($attributes=array ( ), $scenario='init') {
        if ( !isset($attributes["type"]) &&  !isset($attributes["id"]) ) $attributes["type"] = "slide"; // might be overwritten if the Id says we are a template 
        parent::__construct($attributes, $scenario);
    }
    
    public function attributeLabels()
	{
		return array(
            'source'=>Yii::t('app','Template source'),
		);
	}
    
    /*
    public function getWebpathPreview() {
        if ($_source===false) return parent::getWebpathPreview();
        
        $filepath = FileItem::getPathToFile($this->_source, "template" );
        $path = FileItem::getPathToLink($this->_source, "template" );
        if ( file_exists( dirname($filepath)."/.preview.".basename($filepath).".png" ) )
            return dirname($path)."/.preview.".basename($path).".png";
        else
            return self::$previewPath.$this->type.".png";
    }
    */
    
    public static function findAll( $criteria=false, $countOnly=false ) {
        if ( $criteria===false ) {
            $criteria = new CDbCriteria;
            $criteria->condition = "type=:type";
            $criteria->params = array( ":type"=>"slide" );
        } else {
            if ( $criteria->condition && $criteria->condition!="" ) {
                $criteria->condition = $criteria->condition." AND type=:type";
                $criteria->params[":type"] = "slide";
            } else {
                $criteria->condition = "type=:type";
                $criteria->params = array( ":type"=>"slide" );
            }
        }
        return FileItem::findAll( $criteria ) ;
    }
    public function getDatafeedsEntries( $table, $dom ) {
		if ( $table->getAttribute( "ui" )!="datafeed" ) return false;
		// new data feeds for this table
		$entries = array();;
		for ( $item=$table->firstChild; $item!=null; $item=$item->nextSibling ) {
			if ( $item->nodeType==XML_ELEMENT_NODE ) {
				$entry = array();
				$entry['name'] = $item->getAttribute("name");
				$entry['element'] = $item->getAttribute("element");
				$entry['type'] = $item->getAttribute("ui-type");
				if ( $entry['type']=="" ) $entry['type']="text";
				if ( $entry['type']=='image' || $entry['type']=='video' || $entry['type']=='animation') {
					$medias = $dom->getElementsByTagName($entry['type'] );
					foreach ($medias as $media) {
						$href = $media->getAttributeNS("http://www.w3.org/1999/xlink","href");
						if ( strpos($href, "[SPX][".$entry['element']."]")!==false ){
							$entry['position'] = implode(" ",$this->getPostion($media));
							break;
						}
					}
				}
				$entries[] = $entry;
			}
		}
		return $entries;
	}
    protected function createFile( $name, $pathin, $pathout ) {
    
        $template = file_get_contents( $pathin.$name );
        if ( $template===false || $template=="" ) return false;
        
        $dom = new DOMDocument;
        if ( $dom->loadXML( $template )===false ) return false;
        
        // fixing the paths
        $destlink = self::$baseTemplates.$this->pathToLinkFolder();
        $dom->documentElement->setAttribute("xml:base", self::$baseTemplates.$this->linkpath);
        // saving all the default location for the media
        $tags = array("image", "video", "audio", "animation");
        foreach ($tags as $tag){
            $medias = $dom->getElementsByTagName( $tag );
            foreach ($medias as $media) {
                $href = $media->getAttributeNS("http://www.w3.org/1999/xlink","href");
				$media->setAttributeNS("http://www.spinetix.com/namespace/1.0/spx", "spx:default-href", $href );
                if ( strchr($href, "/")===false && pathinfo($href, PATHINFO_EXTENSION)=="svg" ){
                    // this svg will be moved, need to change the reference to the new path
                    $href = $destlink.$href;
                    $media->setAttributeNS("http://www.w3.org/1999/xlink","href", $href );
					$media->setAttributeNS("http://www.spinetix.com/namespace/1.0/spx", "spx:local", "true" );
                }
            }
        }
        
        // create a datafeeds for the tables
        $tables = $dom->getElementsByTagNameNS( "http://www.spinetix.com/namespace/1.0/spx", "table" );
        foreach ($tables as $table) {
			$entries = $this->getDatafeedsEntries( $table, $dom );
            if ( $entries===false ) continue;
            
            // data ?
                
            $id = substr($table->getAttributeNS( "http://www.w3.org/1999/xlink", "href" ), 1);
            $itemElement = $table->getAttribute( "itemElement" );
            $datatable = $dom->getElementById( $id );
            if ( $datatable!=NULL ) {
                $data = array();
                for ( $item=$datatable->firstChild; $item!=null; $item=$item->nextSibling ) {
                    if ( $item->localName==$itemElement ) {
                        $dataItem = array();
                        for ( $elem=$item->firstChild; $elem!=null; $elem=$elem->nextSibling ) {
                            if ($elem->localName!="")
                                $dataItem[$elem->localName] = $elem->textContent;
                        }
                        $data[] = $dataItem ;
                    }
                }
            }
            if ( count($entries)>0 ) {
                $feeds = new Feeds();
                $feeds->name = uniqid( $this->name."_" );
                $feeds->entry = $entries;
                if ( count($data)>0 )
                    $feeds->setData( $data );
                
                $feeds->save();
                
                // need to find the link to the table
                $entrys = array();
                $texts = $dom->getElementsByTagNameNS("http://www.spinetix.com/namespace/1.0/spx", "text");
                foreach ($texts as $text)
                    $entrys[] = $text;
                $choices = $dom->getElementsByTagNameNS("http://www.spinetix.com/namespace/1.0/spx", "choice");
                foreach ($choices as $choice)
                    $entrys[] = $choice;
                foreach ( $entrys as $entry ) {
                    if ( $entry->getAttribute( "ui" )!="enabled" || $entry->getAttribute( "ui-href" )=="") continue;
                    
                    $href = substr( $entry->getAttribute("ui-href"), 1 );
                    $dest = $dom->getElementById( $href );
                    if ( $dest==null ) continue;
                    $value = trim($dest->textContent);
                    if ( $value != "XML-UI" ) continue;
                    $id = substr( $entry->getAttributeNS("http://www.w3.org/1999/xlink","href"), 1 );
                    $dest = $dom->getElementById( $id );
                    if ( $dest===null ) continue;
                    $attrib = $entry->getAttribute("targetAttribute");
                    $attribns = $entry->getAttribute("targetNamespace");
                    if ( $attrib=="" )
                        $dest->nodeValue = $feeds->linkpath;
                    else {
                        if ($attribns=="")
                            $dest->setAttribute($attrib, $feeds->linkpath );
                        else
                            $dest->setAttributeNS($attribns,  $attrib, $feeds->linkpath );
                    }
                    
                }
            }
            
        }
        
        if ( $this->saveSlide( $dom, $pathout.$name )==false ) return false;
        
    }
    protected function pathToFolder() {
        $new = self::getPathToFile( $this->name, "slide" );
        return dirname( $new )."/";
    }
    protected function pathToLinkFolder() {
        $new = self::getPathToLink( $this->name, "slide" );
        return dirname( $new )."/";
    }
    protected function updateId() {
        // update the ID in case we use this object again.
        $this->setId( self::getIdfromName( $this->name, "slide" ) ) ;
    }
    public function create( $replace=true ) {
              
        if ( !file_exists( self::folder("slide") ) )
            mkdir( self::folder("slide") );
            
        $sourceid = $this->id;
        $sourcename = $this->name;
        if ( $this->type!="template" && $this->type!="layout" ) return false;        
        // need to open the template, modify the xml:base and save it under the new name

        $path = dirname( $this->filepath )."/";
        // get the list of all SVG file in this folder
        $files = CFileHelper::findFiles( $path,  array( 'fileTypes'=>array('svg'), 'level'=>0 ) );
        
        // create the destination folder
        if ( preg_match("/^\d+_(.*)/", $this->name, $match) )
            $basename = $match[1];
        else
            $basename = $this->name;
        
        
        for( $i=1; true; $i++ ) {
            $this->name = "Slide$i";
            $destpath = $this->pathToFolder();
            
            if ( !file_exists( $destpath ) ) {
                mkdir( $destpath );
                break;
            } elseif ( $replace ) {
                // clear the folder from all svg file
                $oldfiles = CFileHelper::findFiles( $destpath,  array( 'fileTypes'=>array('svg'), 'level'=>0 ) );
                foreach( $oldfiles as $file )
                    unlink( $file );
                break;
            }
            
            
        }
        
        foreach ( $files as $file ) {
            $this->createFile( basename($file), $path, $this->pathToFolder() );
        }
        
        $oldPreview = $this->getFilepathPreview();
		$oldPreviewLink = $this->getWebpathPreview();
        
        $this->updateId();
        // copy the preview.
        if ( file_exists($oldPreview) ) copy( $oldPreview, $this->getFilepathPreview() );
        
        $this->saveMeta( array( "source"=>array("id"=>$sourceid, 
												"name"=>$sourcename, 
												"path"=>$path, 
												"previewfile"=>$oldPreview,
												"preview"=>$oldPreviewLink,
											)
							) 
						);
        
        return true;
    }   
    
    public function saveSlide( $dom, $name ) {
        return file_put_contents( $name, $dom->saveXML() );
    }
    
    public function getSource() {
        if ( $this->_source===false ) {
            $meta = $this->loadMeta( );
            if ( isset($meta['source']) && isset($meta['source']['id'])) 
                $this->_source = $meta['source']['id'];
            else
                $this->_source = "";
            if ( isset($meta['source']) && isset($meta['source']['name'])) 
                $this->_sourcename = $meta['source']['name'];
            else
                $this->_sourcename = "";
        }
        
        return $this->_source;
    }
    public function getSourceName() {
        if ( $this->_sourcename===false ) {
            $this->getSource();
        }
        if ( preg_match("/^\d+_(.*)/", $this->_sourcename, $match) )
            return $match[1];
        else
            return $this->_sourcename;
    }
	protected function applyTransform( $v, $m ) {
	
		$x=$v[0];
		$y=$v[1];
		$r[0]=$x*$m[0]+$y*$m[1]+$m[4];
		$r[1]=$x*$m[2]+$y*$m[3]+$m[5];
		return $r;
	}
	protected function getPostionSub( $node, $pos ) {
		//transform
		list($x, $y, $width, $height) = $pos;
		
		$transform =  $node->getAttribute("transform");
		if ( substr( $transform, 0, 6) == 'matrix' ){
			$vals = explode(',',substr( $transform,7, -1 ));
			list($x,$y) = $this->applyTransform(array($x,$y), $vals);
			list($width,$height) = $this->applyTransform(array($width,$height), array($vals[0], $vals[1], $vals[2], $vals[3], 0,0) );
		}elseif ( substr( $transform, 0, 9) == 'translate' ){
			$vals = explode(',',substr( $transform,10, -1 ));
			list($x,$y) = $this->applyTransform(array($x,$y), array(1,0,0,1,$vals[0], $vals[1]));
		}elseif ( substr( $transform, 0, 5) == 'scale' ){
			$vals = explode(',',substr( $transform,6, -1 ));
			if (count($vals)==1)
				$vals[1]=$vals[0];
			list($x,$y) = $this->applyTransform(array($x,$y), array($vals[0], 0,0, $vals[1],0,0));
			list($width,$height) = $this->applyTransform(array($width,$height), array($vals[0], 0,0, $vals[1],0,0));
		}
		return array( $x, $y, $width, $height );
	}
    protected function getPostion( $node ) {
		
		$x =  $node->getAttribute("x");
		if ($x=="") $x=0;
		$y =  $node->getAttribute("y");
		if ($y=="") $y=0;
		$width =  $node->getAttribute("width");
		if ($width=="") $width=0;
		$height =  $node->getAttribute("height");
		if ($height=="") $height=0;
		$pos = array($x, $y, $width, $height);
		while ( $node!=null ) {
			$pos = $this->getPostionSub($node,$pos);
			if ( $node->nodeName=='svg' )
				break;
			$node = $node->parentNode;
			
		}
		return $pos;
	}
    protected function getMedia( $dom, $media, $res=false ) {
        while ( $media!=null && $media->localName=="g" ) { // resolving effects
            $target = $media->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx","effect-target-id");
            if ( $target=="" ) break;
            $media = $dom->getElementById( $target );
        }
        if ( $media!=null ) {
            if ( $res===false ) {
                $ui_name = $media->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx","name");
                if ( $ui_name=="" ) return false;
            }
                
            $base = $media;
            if ( $media->localName=="g" ) {
                for ( $text=$media->firstChild; $text!=null; $text=$text->nextSibling ) {
                    if ( $text->localName=="textArea" ) $media = $text; 
                }
            }
            if ( $res===false ) {
                $res = new TemplateEntry;
                $res->scenario = "create";
                $res->name = $ui_name;
                $res->id = $base->getAttribute("xml:id");
                if ( $res->id=="" )
                    $res->id = $base->getAttribute("id");
                if ( $res->id=="" ) return false;
                $res->attrib = "";
            }
            if ( $media->localName=="textArea" ) {
                $res->value ="";
                for ( $node=$media->firstChild; $node!=null; $node=$node->nextSibling )
                    $res->value .= $dom->saveXML($node); //$media->textContent;   
				// replace "\n" by <tbreak/>
				$res->value = str_replace("<tbreak/>", "", $res->value);
                // cleanup HTML code
				$res->value = htmlspecialchars_decode( $res->value );
				$res->type = "textarea";
				
				$res->position=$this->getPostion( $media );
            } else if ( $media->localName=="animation" || $media->localName=="video" || $media->localName=="audio" || $media->localName=="image" ) {
                $href = $media->getAttributeNS("http://www.w3.org/1999/xlink","href");
                if ( !(strpos($href , self::$baseTemplates)===false) )
                    $href  = substr( $href , strlen(self::$baseTemplates) );
                $file = new FileItem(array("linkpath" => $href ) );
                $res->value = $file->id;
                $res->type = $media->localName;
				
				$res->position=implode(" ", $this->getPostion( $media ));
				
            }
        }
        return $res;
    }
    
    protected function loadFile( $name ) {
        if ( !file_exists( $name) ) return false;
            
        $slide = file_get_contents( $name );
        if ( $slide===false || $slide=="" ) return false;
        
        $dom = new DOMDocument;
        if ( $dom->loadXML( $slide )===false ) return false;
        
		$this->viewBox = $dom->documentElement->getAttribute('viewBox');			
		
        $restitle = new TemplateEntry;
        $title = $dom->getElementsByTagName("title");
        if ( $title->length>=1 )
            $restitle->name = trim($title->item(0)->textContent);
        else
            $restitle->name ="New Document";
        $restitle->type='file';
        $restitle->id=basename($name);
        $this->_fields[]=$restitle;
        $gotone=false;
        $params = $dom->getElementsByTagNameNS("http://www.spinetix.com/namespace/1.0/spx", "properties");
        
        foreach( $params as $param ) {
            
            $entrys = array();
			for ( $item=$param->firstChild; $item!=null; $item=$item->nextSibling ) {
				if ( $item->nodeType==XML_ELEMENT_NODE ) {
					if ($item->localName!='table') // handled latter
					 $entrys[] = $item;
				}
			}

                
            foreach ($entrys as $entry) {
                
                if ( $entry->getAttribute( "ui" )!="enabled" ) 
                    continue;
                $res = new TemplateEntry;
                $res->scenario = "create";
                $res->name = $entry->getAttribute("name");
                $res->id = substr( $entry->getAttributeNS("http://www.w3.org/1999/xlink","href"), 1 );
                $res->attrib = $entry->getAttribute("targetAttribute");
                $res->attribns = $entry->getAttribute("targetNamespace");
                $dest = $dom->getElementById( $res->id );
                if ( $dest===null ) continue;
                // we want the User to explicitly enable the ui settings
				
				if ( $entry->localName=="media" ) {
                    $res = $this->getMedia( $dom, $dest , $res );
                    if ( $res===false ) continue;
                } else {
                    if ( $res->attrib=="" )
                        $res->value = htmlspecialchars_decode($dest->textContent);
                    else {
                        if ($res->attribns=="")
                            $res->value = $dest->getAttribute($res->attrib );
                        else
                            $res->value = $dest->getAttributeNS($res->attribns,  $res->attrib );
                    }
                    $res->type = $entry->localName;
                }
				if ( $res->type=="choice" ) {
					// get the choice
					$res->choice = "";
					for ($i=1; ;$i++ ) {
						$s = $i;
                        $val = $entry->getAttribute("choice-".$s);
						if ( $val==""  && $s<10) {
							$s = "0".$i;
						    $val = $entry->getAttribute("choice-".$s);
                        }
						if ( $val=="" )
							break;
						if ($res->choice!="")
							$res->choice.="~;~";
						$res->choice.= $val;
					};
				}	
				if ( $res->type=="yesno" || $res->type=="yesnoinherit" || $res->type=="fonts" ) {
					$res->choice = $res->type;
					$res->type = "choice";
				}
                if ( $entry->getAttribute( "ui-href" )!="" ) {
                    $href = substr( $entry->getAttribute("ui-href"), 1 );
                    $dest = $dom->getElementById( $href );
                    if ( $dest!=null ) {
                        $value = trim($dest->textContent);
                        if ( $value == "XML-UI" ) {
                            $res->type = 'datafeeds';
                            if ( $res->value=="inline" ) {
                                $res->value = "";
								if ($this->type=='template') {
									$tables = $dom->getElementsByTagNameNS( "http://www.spinetix.com/namespace/1.0/spx", "table" );
									foreach ( $tables as $table) {
										$this->datafeedsentries=$this->getDatafeedsEntries( $table, $dom );
										if ( $this->datafeedsentries!==false )
											break;
									}
								}
                            } else {
                                $file = new FileItem(array("linkpath" => $res->value ) );
                                $res->value = $file->id;
                            }
							$config =$dom->getElementById("rss_multi");
							if ( $config ) {
								$col=$config->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx","rss_num_col");
								$row=$config->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx","rss_num_row");
								$width=$config->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx","rss_x_offset");
								$height=$config->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx","rss_y_offset");
								$res->position="$col $row $width $height ";
								$this->itemPerPage=$col*$row;
							}else
								$this->itemPerPage=1; // don't know
                        }
                    }
                }
                $gotone=true;
                $this->_fields[]=$res;
            }
            
            
            $tables = $param->getElementsByTagNameNS("http://www.spinetix.com/namespace/1.0/spx", "table");
            foreach ($tables as $entry){
                if ( $entry->getAttribute( "ui" )!="enabled" ) continue;
                $name = $entry->getAttribute("name");
                $itemElement = $entry->getAttribute("itemElement");
                $tableElement = $entry->getAttribute("tableElement");
                $id = substr( $entry->getAttributeNS("http://www.w3.org/1999/xlink","href"), 1 );
                $table = $dom->getElementById( $id );
                if ( $table===null ) continue;
                $idx = 0;
                
                for ( $item=$table->firstChild; $item!=null; $item=$item->nextSibling ) if ( $item->localName==$itemElement ) {
                    for ( $tmp=$item->firstChild; $tmp!=null; $tmp=$tmp->nextSibling ) if ( $tmp->nodeType==XML_ELEMENT_NODE ) break;
                    if ( $tmp==null) continue;
                    for ( $media=$tmp->firstChild; $media!=null; $media=$media->nextSibling ) 
                        if ( $media->localName=="animation" || $media->localName=="image" || $media->localName=="video" || $media->localName=="textArea" || $media->localName=="audio" || $media->localName=="g" ) break;
                    
                    $res = $this->getMedia( $dom, $media );
                    if ( $res===false ) continue;
                    $gotone=true;
                    $this->_fields[]=$res;
                }
            }
        }
        if ( !$gotone && count($this->_fields)>1 ) {
            array_pop( $this->_fields );
        }
    }
	
	public function getTemplatePreview() {
		if ( $this->type=='template' )
			return $this->getWebpathPreview();
		if ($this->_templatepreview===false) {
			$meta = $this->loadMeta();
			if (isset($meta['source']) && isset($meta['source']['preview']))
				$this->_templatepreview = $meta['source']['preview'];
			else
				$this->_templatepreview = "";
		}
		return $this->_templatepreview;
	}
	public function setPreviews( $prev ) {
		$this->previews = $prev;
	}
	
	public function getPreviews() {
		$meta = loadMeta();
		return $meta['preview'];
	}
    
    public function getFields() {
  
        if ( $this->_fields===false ) {
            
            $this->_fields = array( );
            
            $this->loadFile( $this->filepath );
            
            $path = dirname( $this->filepath )."/";
            // get the list of all SVG file in this folder
            $files = CFileHelper::findFiles( $path,  array( 'fileTypes'=>array('svg'), 'level'=>0 ) );
            foreach ( $files as $file ) {
                if ( basename($file)==basename($this->filepath) ) continue;
                $this->loadFile( $file );
            }
            //if ( count($this->_fields)>1 && $this->_fields[0]->type=="file" && $this->_fields[1]->type=="file" )
            //   array_shift( $this->_fields ); // because we always keep the first file. But if it was empty and the second file is not, then we remove it
            
        } 
            
        return $this->_fields;
    }
    
    public function setFields( $fields ) {
        $this->_fields = $fields;
		
    }
    
    protected function saveFile( $name, $data ) {
        if ( !file_exists( $name ) ) return false;
        
        
        $feedsList = array();
            
        $slide = file_get_contents( $name );
        if ( $slide===false || $slide=="" ) return false;
        
        $dom = new DOMDocument;
        if ( $dom->loadXML( $slide )===false ) return false;
        
        while ( count($data)>0 && $data[0]->type!='file' ){
            $item = array_shift( $data );
            $dest = $dom->getElementById( $item->id );
            if ($dest==null) continue;
            $value = $item->value;
            if ( $item->type=="datafeeds" ) {
                $feedsList[]= $value;
                if ( $value !="" ) {
                    $file = new FileItem(array("id" => $item->value) );
                    $value  = self::$baseTemplates.$file->linkpath;
                } else
                    $value  = "inline";
            }
            if ( $item->type=="text" || $item->type=="color" || $item->type=="choice" || $item->type=="datafeeds") {
                if ( $item->attrib=="" )
                    $dest->nodeValue = htmlspecialchars($value, ENT_NOQUOTES, 'UTF-8');
                else {
                    if ($item->attribns=="")
                        $dest->setAttribute( $item->attrib, $value  );
                    else
                        $dest->setAttributeNS( $item->attribns , $item->attrib, $value  );
                }
            } elseif ( $item->type=="rich" || $item->type=="textarea") {
                if ( $dest->localName=="g" ) {
                    for ( $text=$dest->firstChild; $text!=null; $text=$text->nextSibling )
                        if ( $text->localName=="textArea" ) $dest = $text; 
                }
                $dest->nodeValue = ""; // clear
				// cleanup HTML code
				$value = htmlspecialchars($value, ENT_NOQUOTES, 'UTF-8');
				// replace "\n" by <tbreak/>
				$value = str_replace("\n","<tbreak/>", $value);
                $frag = $dom->createDocumentFragment();
                $frag->appendXML( $value );
                $dest->appendChild($frag);
            }elseif ( $item->type=="animation" || $item->type=="image" || $item->type=="video" || $item->type=="audio") {
            
                if ( $value==false || $value=="" ) {
                    $dest->setAttributeNS( "http://www.w3.org/1999/xlink", "href", $dest->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx", "default-href") );
                } else {
                    $file = new FileItem(array("id" => $value ) );
                    $dest->setAttributeNS( "http://www.w3.org/1999/xlink", "href", self::$baseTemplates.$file->linkpath);
                    $dest->setAttributeNS("http://www.spinetix.com/namespace/1.0/spx", "local", "false" );
                }
            } 
        };
        if ( !empty($feedsList) ) {
            $oldfeedsList = array();
            $meta = $this->loadFeedMeta( $sources, $oldfeedsList );
            
            $this->addFeeds( $meta, $feedsList, $sources );
            $this->saveFeedMeta( $meta );
            
			$meta = $this->loadMeta();
			$meta['feeds']=$feedsList;
			$this->saveMeta( $meta );
        }
		// fixing the paths
        $destlink = self::$baseTemplates.$this->pathToLinkFolder();
		$medias = $dom->getElementsByTagName( "animation" );
		foreach ($medias as $media) {
			$local = $media->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx", "local" );
			if ( $local=="true" ) {
				$href = $media->getAttributeNS("http://www.spinetix.com/namespace/1.0/spx", "default-href");
				// this svg will be moved, need to change the reference to the new path
				$href = $destlink.$href;
				$media->setAttributeNS("http://www.w3.org/1999/xlink","href", $href );
			}
		}
        $this->_source=false;
        $this->_sourcename=false;
        return ( $this->saveSlide( $dom, $name )!==false );
        
    }
    
    function loadFeedMeta( &$sources=array(), &$feedsList=array() ) {
    
        $feeds = new Feeds( array('name'=>'dummy') );
        $meta = $feeds->loadMeta();
        
        $newmeta=array();
        $sources=array();
        $idx=0;
        foreach ( $meta as $metaname=>$value ) {
            if ( substr($metaname,0,5)!="slide" )
                $newmeta[$metaname]=$value; // copy the meta not for us
            else if ( $value['idslide']!=$this->id ){
                // this is another slide, is it using the same feeds ?
                foreach ( $value as $n=>$v ){
                    if ( substr($n,0,5)=="feeds")
                        $sources[$v][]=$value['idslide'];
                }
                $newmeta["slide".$idx]=$value; // copy the meta not for us
                $idx++;
            } else {
                foreach ( $value as $n=>$v )
                    if ( substr($n,0,5)=="feeds")
                        $feedsList[] = $v;
            }
        }
        
        return $newmeta;
    }
    function addFeeds( &$newmeta, $feedsList=array(), &$sources=array() ) {
        $idx=0;
        foreach ($newmeta as $name=>$value )
            if ( substr($name,0,5)=="slide" ) $idx++;
        
        $newmeta["slide".$idx]['idslide']=$this->id;
        
        foreach( $feedsList as $i=>$id ){
            $sources[$id ][]=$this->id;
            $newmeta["slide".$idx]["feeds".$i]=$id;
        }
    }
    
    function saveFeedMeta( $newmeta ) {
        // write our data
        $feeds = new Feeds( array('name'=>'dummy') );
        $feeds->saveMeta( $newmeta );
        
    }

    public function save () {
        
        $meta = $this->loadMeta( );
        
        if ( $this->_fields===false ) {
            return parent::save();
        } else {
            $data = $this->_fields;
           
            while ( count($data)>0 ) {
                $temp =  array_shift( $data );
                if ( $temp->type!='file' ) continue;
				
                $this->saveFile( dirname( $this->filepath )."/".$temp->id, $data );
            };
        }
        
        $meta['modified']=true;
		
		
		$previews = array();
		$meta['previews'] = array();
		foreach ($this->previews as $n=>$data ){
			foreach ( $data as $pos=>$val ){
				if ($val=="") continue;
				if ( !isset($previews[$pos]) )
					$previews[$pos]=$val; // remove duplicate media at the same postion
				$meta['previews'][] = $val;
			}
		}
        if ( $this->enablepreview ) {
		//if ( count($previews)>0 ) {
			//update the preview
			$this->createPreview( $previews, $meta );
		//}
        }
		
        $this->saveMeta( $meta );
        
        return true;
    }
	
	public function createPreview( $previews, $meta ) {
        
        $exe="cd /srv/raperca && raperca";
        if(PHP_OS == "WINNT")
            $exe = "C:\\svn\\genesis\\trunk\\device\\debug\\raperca.exe";
        
        $where = dirname($this->getFilepath());
        if ( $this->type=='layout')
            $file = "skin.svg";
        else
            $file = "template.svg";
        $where = "'" . str_replace("'", "'\\''", $where) . "'";
        $cmd = "$exe -preview -xh -d ".$where." -s 330x195 $file";
        
        //file_put_contents("debug.log", $cmd."\n".$this->type."\n", FILE_APPEND);
        
        exec( $cmd );
        
        return;
        
        
        $newImage = imagecreatetruecolor(160, 90);
        imagefill( $newImage , 0, 0, imagecolorallocate( $newImage, 255, 255, 255 ) );
        
		// the source
		if ( !isset($meta['source']) )
			return; // cannot create previews
		$img = $meta['source']['previewfile'];;
		$info = getimagesize( $img );
		$image = imagecreatefrompng( $img );
		$height = 90;
        $width = $info[0]*$height/$info[1];
		if ($width>160) {
			$width=160;
			$height = $width*$info[1]/$info[0];
		}
		$offx = (160-$width)/2;
		$offy = (90-$height)/2;
		imagecopyresampled( $newImage, $image, $offx, $offy, 0, 0, $width, $height, $info[0], $info[1] );
		// the previews
		foreach( $previews as $pos=>$link ){
            
            if ($link=="") continue;
			$img = FileItem::getFileFromWeb($link);
			$info = getimagesize( $img );
			$image = imagecreatefrompng( $img );
			$p = explode(" ", $pos);
			$v = explode(" ", $this->viewBox);
			$x = $p[0]/$v[2]*$width+$offx;
			$y = $p[1]/$v[3]*$height+$offy;
			$w = $p[2]/$v[2]*$width;
			$h = $p[3]/$v[3]*$height;
			imagecopyresampled( $newImage, $image, $x, $y, 0, 0, $w, $h, $info[0], $info[1] );
		}
		imagepng( $newImage, $this->getFilepathPreview() );
	}
    public function delete () {
        $feedsList = array();
        $meta = $this->loadFeedMeta( $sources,  $feedsList );
        
        if ( parent::delete()===false ) return false;
        
        foreach ( $feedsList as $feedid ) {
            if (!isset( $sources[$feedid]) ){
                // we are the only user of this feed.
                $feed = new Feeds( array('id'=>$feedid) ); 
                $feed->delete();
            }
        }
        
        $this->saveFeedMeta( $meta  );
        
        return true;
    }
    public function copy () {
        
        $feedsList = array();
        $meta = $this->loadFeedMeta( $sources,  $feedsList );
        $this->addFeeds( $meta, $feedsList, $sources ); // add the orignal user
        if ( parent::copy()===false ) return false;
        $this->addFeeds( $meta, $feedsList, $sources ); // add the new user
        $this->saveFeedMeta( $meta );
        
        return true;
    }
    public function rename () {
    
        $feedsList = array();
        $meta = $this->loadFeedMeta( $sources,  $feedsList );
        if ( parent::rename()===false ) return false;
        $this->addFeeds( $meta, $feedsList, $sources ); // add the new user
        $this->saveFeedMeta( $meta, $feedsList, $sources );
        
        return true;
    }
    
    static function mapToFolder( $templates ) {
        $folders = array();
        foreach ($templates as $template ) {
            $dest = self::removeFolderName( $template->name );
            $folders[$dest][] = $template;
        }
        return $folders;
    }
    static function folders(){
        return array( "" => Yii::t('app',"Simple"),
                                "multi_" => Yii::t('app',"Advanced"),
                                "news_" => Yii::t('app',"RSS Feeds"),
                                "others_" => Yii::t('app',"Others"),
                                );
    }
    static function removeFolderName( &$template_name ) {
        $f = self::folders();
        $dest = $f[""];
		$rem="";
        foreach ( $f as $key => $name ) {
            $pos = strrpos( $template_name, $key );
            if ( $pos!==false && $pos==0 ) {
                $dest = $name;
                $rem = $key;
            }
        }
        $template_name = substr( $template_name, strlen($rem) );
        return $dest;
    }
}