<?php
class TimeSettings extends CFormModel {
	
    var $tzarea='Etc';
    var $tzcity=null;
    var $link=null;
    
    
    var $tzmap=array("Africa" => "Africa", "America" => "America", "US" => "US time zones", "Canada" => "Canada time zones",
                 "Asia" => "Asia", "Atlantic" => "Atlantic Ocean", "Australia" => "Australia", "Europe" => "Europe",
                 "Indian" => "Indian Ocean", "Pacific" => "Pacific Ocean", "Etc" => "GMT Offset");
             
    
    /**
	 * @return array validation rules for model attributes.
	 */
	public function rules() {
		return array(
			array('link, shortlink', 'safe', 'on'=>'timezone'),
		);
	}
    
    public function attributeLabels()
	{
		return array(
            'tzcity'=>'Use this interface for the network: ',
            'time'=>'Local time',
            'link'=>'Time Zone',        
    	);
	}
    
    function getShortlink(){
		return $this->tzarea."/".$this->tzcity;
	}
	function setShortlink( $link ){
		$this->link = "/usr/share/zoneinfo/".$link;
	}
    
    function load() {
        if ( $_ENV['OS']=='Windows_NT' ) {
            if ( file_exists("/etc/localtime.link") ){
                $realpath = file_get_contents("/etc/localtime.link");
                $this->link = $realpath;
            }else {
                $realpath="../usr/share/zoneinfo/Europe/Zurich";
                $this->link = "/usr/share/zoneinfo/Europe/Zurich";
            }
        } else {
            $realpath = readlink( "/etc/localtime" );
            if ( substr($realpath,0,1)!='/' )
                $this->link = realpath("/etc/" . $realpath);
            else
                $this->link = $realpath;
        }
        $inf  =split( "/", $realpath );
        
        $this->tzarea = $inf[count($inf)-2];
        $this->tzcity = $inf[count($inf)-1];
        
    }
    
    function getTimezones() {
        $path = "/usr/share/zoneinfo";
        
        $filelist = scandir($path);
        natsort( $filelist );
        
        foreach($filelist as $file){
            if ($file[0]!='.' && is_dir($path."/".$file) ) {
                $area=array();
                $tzpath=$path."/".$file;
                $tzfilelist=scandir($tzpath);
                natsort($tzfilelist);
                foreach($tzfilelist as $tzfile){
                    if ($tzfile[0]=='.' || is_dir($tzpath."/".$tzfile) ) continue;
                    $area[$tzfile]=$tzpath."/".$tzfile;
                }	
                $timezones[$file]=$area;
            }
        }
        
        return $timezones;
    }
    
    function save() {
        Yii::app()->user->tools->save_symlink( $this->link, "/etc/localtime" );
        Yii::app()->user->tools->addReason("Timezone changed");
    }    
}